Require Import bool.
Require Import connectives.
Require Import leibniz.
Require Import logic.
Parameter nat : Type.
Parameter O : nat.
Parameter S : nat -> nat.
Axiom match_nat_prop : forall (return_:(nat -> Prop)), (return_ O) -> (forall (n:nat), return_ (S n)) -> forall (z:nat), return_ z.
Parameter match_nat_type : forall (return_:Type), return_ -> (nat -> return_) -> nat -> return_.
Axiom axiom_match_nat_type_O : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), connectives.equal (return_type) (match_nat_type (return_type) case_O case_S O) case_O.
Definition eq_match_nat_type_O : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), leibniz.leibniz (return_type) (match_nat_type (return_type) case_O case_S O) case_O := fun (return_type:Type) => fun (case_O:return_type) => fun (case_S:nat -> return_type) => ((((connectives.equal_leibniz) (return_type)) (match_nat_type (return_type) case_O case_S O)) (case_O)) ((((axiom_match_nat_type_O) (return_type)) (case_O)) (case_S)).
Definition sym_eq_match_nat_type_O : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), leibniz.leibniz (return_type) case_O (match_nat_type (return_type) case_O case_S O) := fun (return_type:Type) => fun (case_O:return_type) => fun (case_S:nat -> return_type) => ((((leibniz.sym_leibniz) (return_type)) (match_nat_type (return_type) case_O case_S O)) (case_O)) ((((eq_match_nat_type_O) (return_type)) (case_O)) (case_S)).
Axiom axiom_match_nat_type_S : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), forall (n:nat), connectives.equal (return_type) (match_nat_type (return_type) case_O case_S (S n)) (case_S n).
Definition eq_match_nat_type_S : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (match_nat_type (return_type) case_O case_S (S n)) (case_S n) := fun (return_type:Type) => fun (case_O:return_type) => fun (case_S:nat -> return_type) => fun (n:nat) => ((((connectives.equal_leibniz) (return_type)) (match_nat_type (return_type) case_O case_S (S n))) (case_S n)) (((((axiom_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
Definition sym_eq_match_nat_type_S : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (case_S n) (match_nat_type (return_type) case_O case_S (S n)) := fun (return_type:Type) => fun (case_O:return_type) => fun (case_S:nat -> return_type) => fun (n:nat) => ((((leibniz.sym_leibniz) (return_type)) (match_nat_type (return_type) case_O case_S (S n))) (case_S n)) (((((eq_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
Parameter filter_nat_type : forall (return_:Type), (nat -> return_) -> nat -> return_.
Axiom axiom_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), connectives.equal (return_type) (filter_nat_type (return_type) return_ O) (return_ O).
Definition eq_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), leibniz.leibniz (return_type) (filter_nat_type (return_type) return_ O) (return_ O) := fun (return_type:Type) => fun (return_:nat -> return_type) => ((((connectives.equal_leibniz) (return_type)) (filter_nat_type (return_type) return_ O)) (return_ O)) (((axiom_filter_nat_type_O) (return_type)) (return_)).
Definition sym_eq_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), leibniz.leibniz (return_type) (return_ O) (filter_nat_type (return_type) return_ O) := fun (return_type:Type) => fun (return_:nat -> return_type) => ((((leibniz.sym_leibniz) (return_type)) (filter_nat_type (return_type) return_ O)) (return_ O)) (((eq_filter_nat_type_O) (return_type)) (return_)).
Axiom axiom_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), connectives.equal (return_type) (filter_nat_type (return_type) return_ (S n)) (return_ (S n)).
Definition eq_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (filter_nat_type (return_type) return_ (S n)) (return_ (S n)) := fun (return_type:Type) => fun (return_:nat -> return_type) => fun (n:nat) => ((((connectives.equal_leibniz) (return_type)) (filter_nat_type (return_type) return_ (S n))) (return_ (S n))) ((((axiom_filter_nat_type_S) (return_type)) (return_)) (n)).
Definition sym_eq_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (return_ (S n)) (filter_nat_type (return_type) return_ (S n)) := fun (return_type:Type) => fun (return_:nat -> return_type) => fun (n:nat) => ((((leibniz.sym_leibniz) (return_type)) (filter_nat_type (return_type) return_ (S n))) (return_ (S n))) ((((eq_filter_nat_type_S) (return_type)) (return_)) (n)).
Axiom nat_ind : forall (Q:(nat -> Prop)), (Q O) -> (forall (x:nat), (Q x) -> Q (S x)) -> forall (x:nat), Q x.
Definition pred : nat -> nat := fun (n:nat) => match_nat_type (nat) O (fun (p:nat) => p) n.
Definition not_zero : nat -> Prop := fun (n:nat) => match_nat_type (Prop) connectives.False (fun (p:nat) => connectives.True) n.
Definition nat_elim2 : forall (R:(nat -> nat -> Prop)), (forall (n:nat), R O n) -> (forall (n:nat), R (S n) O) -> (forall (n:nat), forall (m:nat), (R n m) -> R (S n) (S m)) -> forall (n:nat), forall (m:nat), R n m := fun (R:nat -> nat -> Prop) => fun (ROn:forall (n:nat), R O n) => (fun (RSO:forall (n:nat), R (S n) O) => (fun (RSS:forall (n:nat), forall (m:nat), (R n m) -> R (S n) (S m)) => (fun (n:nat) => ((((nat_ind) (fun (_x_365:nat) => forall (m:nat), R _x_365 m)) (fun (m:nat) => (ROn) (m))) (fun (n0:nat) => fun (Rn0m:forall (m:nat), R n0 m) => (fun (m:nat) => ((((match_nat_prop) (fun (__:nat) => R (S n0) __)) ((RSO) (n0))) (fun (auto:nat) => (((RSS) (n0)) (auto)) ((Rn0m) (auto)))) (m)))) (n)))).
Definition pred_Sn : forall (n:nat), logic.eq (nat) n (pred (S n)) := fun (n:nat) => ((((((sym_eq_match_nat_type_S) (nat)) (O)) (fun (p:nat) => p)) (n)) (fun (y:nat) => logic.eq (nat) n y)) (((logic.refl) (nat)) (n)).
Definition not_eq_S : forall (n:nat), forall (m:nat), (connectives.Not (logic.eq (nat) n m)) -> connectives.Not (logic.eq (nat) (S n) (S m)) := fun (n:nat) => fun (m:nat) => fun (auto:connectives.Not (logic.eq (nat) n m)) => (((((logic.not_to_not) (logic.eq (nat) (S n) (S m))) (logic.eq (nat) n m)) (fun (auto':logic.eq (nat) (S n) (S m)) => (((((((logic.rewrite_l) (nat)) (m)) (fun (__:nat) => logic.eq (nat) __ m)) (((logic.refl) (nat)) (m))) (n)) (((((((logic.rewrite_r) (nat)) (pred (S n))) (fun (__:nat) => logic.eq (nat) m __)) (((((((logic.rewrite_r) (nat)) (S m)) (fun (__:nat) => logic.eq (nat) m (pred __))) ((pred_Sn) (m))) (S n)) (auto'))) (n)) ((pred_Sn) (n)))))) (auto)).
Definition not_eq_O_S : forall (n:nat), connectives.Not (logic.eq (nat) O (S n)) := fun (n:nat) => ((connectives.nmk) (logic.eq (nat) O (S n))) (fun (eqOS:logic.eq (nat) O (S n)) => ((((((eq_match_nat_type_O) (Prop)) (connectives.False)) (fun (p:nat) => connectives.True)) (fun (y:Prop) => y)) (((((((logic.eq_ind_r) (nat)) (S n)) (fun (x:nat) => not_zero x)) (((((((sym_eq_match_nat_type_S) (Prop)) (connectives.False)) (fun (p:nat) => connectives.True)) (n)) (fun (y:Prop) => y)) (connectives.I))) (O)) (eqOS)))).
Parameter eqb : nat -> nat -> bool.bool.
Parameter eqb_body : nat -> nat -> bool.bool.
Axiom axiom_eqb : forall (n:nat), connectives.equal (nat -> bool.bool) (eqb n) (filter_nat_type (nat -> bool.bool) eqb_body n).
Definition eq_eqb : forall (n:nat), leibniz.leibniz (nat -> bool.bool) (eqb n) (filter_nat_type (nat -> bool.bool) eqb_body n) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> bool.bool)) (eqb n)) (filter_nat_type (nat -> bool.bool) eqb_body n)) ((axiom_eqb) (n)).
Definition sym_eq_eqb : forall (n:nat), leibniz.leibniz (nat -> bool.bool) (filter_nat_type (nat -> bool.bool) eqb_body n) (eqb n) := fun (n:nat) => ((((leibniz.sym_leibniz) (nat -> bool.bool)) (eqb n)) (filter_nat_type (nat -> bool.bool) eqb_body n)) ((eq_eqb) (n)).
Axiom axiom_eqb_body_O : connectives.equal (nat -> bool.bool) (eqb_body O) (fun (m:nat) => match_nat_type (bool.bool) bool.true (fun (q:nat) => bool.false) m).
Definition eq_eqb_body_O : leibniz.leibniz (nat -> bool.bool) (eqb_body O) (fun (m:nat) => match_nat_type (bool.bool) bool.true (fun (q:nat) => bool.false) m) := ((((connectives.equal_leibniz) (nat -> bool.bool)) (eqb_body O)) (fun (m:nat) => match_nat_type (bool.bool) bool.true (fun (q:nat) => bool.false) m)) (axiom_eqb_body_O).
Definition sym_eq_eqb_body_O : leibniz.leibniz (nat -> bool.bool) (fun (m:nat) => match_nat_type (bool.bool) bool.true (fun (q:nat) => bool.false) m) (eqb_body O) := ((((leibniz.sym_leibniz) (nat -> bool.bool)) (eqb_body O)) (fun (m:nat) => match_nat_type (bool.bool) bool.true (fun (q:nat) => bool.false) m)) (eq_eqb_body_O).
Axiom axiom_eqb_body_S : forall (n:nat), connectives.equal (nat -> bool.bool) (eqb_body (S n)) (fun (m:nat) => match_nat_type (bool.bool) bool.false (fun (q:nat) => eqb n q) m).
Definition eq_eqb_body_S : forall (n:nat), leibniz.leibniz (nat -> bool.bool) (eqb_body (S n)) (fun (m:nat) => match_nat_type (bool.bool) bool.false (fun (q:nat) => eqb n q) m) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> bool.bool)) (eqb_body (S n))) (fun (m:nat) => match_nat_type (bool.bool) bool.false (fun (q:nat) => eqb n q) m)) ((axiom_eqb_body_S) (n)).
Definition sym_eq_eqb_body_S : forall (n:nat), leibniz.leibniz (nat -> bool.bool) (fun (m:nat) => match_nat_type (bool.bool) bool.false (fun (q:nat) => eqb n q) m) (eqb_body (S n)) := fun (n:nat) => ((((leibniz.sym_leibniz) (nat -> bool.bool)) (eqb_body (S n))) (fun (m:nat) => match_nat_type (bool.bool) bool.false (fun (q:nat) => eqb n q) m)) ((eq_eqb_body_S) (n)).
Definition eqb_elim : forall (n:nat), forall (m:nat), forall (P:(bool.bool -> Prop)), ((logic.eq (nat) n m) -> P bool.true) -> ((connectives.Not (logic.eq (nat) n m)) -> P bool.false) -> P (eqb n m) := ((((nat_elim2) (fun (__:nat) => fun (_0:nat) => forall (P:(bool.bool -> Prop)), ((logic.eq (nat) __ _0) -> P bool.true) -> ((connectives.Not (logic.eq (nat) __ _0)) -> P bool.false) -> P (eqb __ _0))) (fun (n:nat) => ((((match_nat_prop) (fun (__:nat) => forall (P:(bool.bool -> Prop)), ((logic.eq (nat) O __) -> P bool.true) -> ((connectives.Not (logic.eq (nat) O __)) -> P bool.false) -> P (eqb O __))) ((((sym_eq_eqb) (O)) (fun (y:(nat -> bool.bool)) => forall (P:(bool.bool -> Prop)), ((logic.eq (nat) O O) -> P bool.true) -> ((connectives.Not (logic.eq (nat) O O)) -> P bool.false) -> P (y O))) (((((sym_eq_filter_nat_type_O) (nat -> bool.bool)) (eqb_body)) (fun (y:(nat -> bool.bool)) => forall (P:(bool.bool -> Prop)), ((logic.eq (nat) O O) -> P bool.true) -> ((connectives.Not (logic.eq (nat) O O)) -> P bool.false) -> P (y O))) (((sym_eq_eqb_body_O) (fun (y:(nat -> bool.bool)) => forall (P:(bool.bool -> Prop)), ((logic.eq (nat) O O) -> P bool.true) -> ((connectives.Not (logic.eq (nat) O O)) -> P bool.false) -> P (y O))) ((((((sym_eq_match_nat_type_O) (bool.bool)) (bool.true)) (fun (q:nat) => bool.false)) (fun (y:bool.bool) => forall (P:(bool.bool -> Prop)), ((logic.eq (nat) O O) -> P bool.true) -> ((connectives.Not (logic.eq (nat) O O)) -> P bool.false) -> P y)) (fun (P:bool.bool -> Prop) => fun (auto:(logic.eq (nat) O O) -> P bool.true) => (fun (auto':(connectives.Not (logic.eq (nat) O O)) -> P bool.false) => ((auto) (((logic.refl) (nat)) (O)))))))))) (fun (auto:nat) => (((sym_eq_eqb) (O)) (fun (y:(nat -> bool.bool)) => forall (P:(bool.bool -> Prop)), ((logic.eq (nat) O (S auto)) -> P bool.true) -> ((connectives.Not (logic.eq (nat) O (S auto))) -> P bool.false) -> P (y (S auto)))) (((((sym_eq_filter_nat_type_O) (nat -> bool.bool)) (eqb_body)) (fun (y:(nat -> bool.bool)) => forall (P:(bool.bool -> Prop)), ((logic.eq (nat) O (S auto)) -> P bool.true) -> ((connectives.Not (logic.eq (nat) O (S auto))) -> P bool.false) -> P (y (S auto)))) (((sym_eq_eqb_body_O) (fun (y:(nat -> bool.bool)) => forall (P:(bool.bool -> Prop)), ((logic.eq (nat) O (S auto)) -> P bool.true) -> ((connectives.Not (logic.eq (nat) O (S auto))) -> P bool.false) -> P (y (S auto)))) (((((((sym_eq_match_nat_type_S) (bool.bool)) (bool.true)) (fun (q:nat) => bool.false)) (auto)) (fun (y:bool.bool) => forall (P:(bool.bool -> Prop)), ((logic.eq (nat) O (S auto)) -> P bool.true) -> ((connectives.Not (logic.eq (nat) O (S auto))) -> P bool.false) -> P y)) (fun (P:bool.bool -> Prop) => fun (auto':(logic.eq (nat) O (S auto)) -> P bool.true) => (fun (auto'':(connectives.Not (logic.eq (nat) O (S auto))) -> P bool.false) => ((auto'') ((not_eq_O_S) (auto)))))))))) (n))) (fun (n:nat) => (((sym_eq_eqb) (S n)) (fun (y:(nat -> bool.bool)) => forall (P:(bool.bool -> Prop)), ((logic.eq (nat) (S n) O) -> P bool.true) -> ((connectives.Not (logic.eq (nat) (S n) O)) -> P bool.false) -> P (y O))) ((((((sym_eq_filter_nat_type_S) (nat -> bool.bool)) (eqb_body)) (n)) (fun (y:(nat -> bool.bool)) => forall (P:(bool.bool -> Prop)), ((logic.eq (nat) (S n) O) -> P bool.true) -> ((connectives.Not (logic.eq (nat) (S n) O)) -> P bool.false) -> P (y O))) ((((sym_eq_eqb_body_S) (n)) (fun (y:(nat -> bool.bool)) => forall (P:(bool.bool -> Prop)), ((logic.eq (nat) (S n) O) -> P bool.true) -> ((connectives.Not (logic.eq (nat) (S n) O)) -> P bool.false) -> P (y O))) ((((((sym_eq_match_nat_type_O) (bool.bool)) (bool.false)) (fun (q:nat) => eqb n q)) (fun (y:bool.bool) => forall (P:(bool.bool -> Prop)), ((logic.eq (nat) (S n) O) -> P bool.true) -> ((connectives.Not (logic.eq (nat) (S n) O)) -> P bool.false) -> P y)) (fun (P:bool.bool -> Prop) => fun (auto:(logic.eq (nat) (S n) O) -> P bool.true) => (fun (auto':(connectives.Not (logic.eq (nat) (S n) O)) -> P bool.false) => ((auto') (((((logic.sym_not_eq) (nat)) (O)) (S n)) ((not_eq_O_S) (n))))))))))) (fun (n:nat) => fun (m:nat) => (((sym_eq_eqb) (S n)) (fun (y:(nat -> bool.bool)) => (forall (P:(bool.bool -> Prop)), ((logic.eq (nat) n m) -> P bool.true) -> ((connectives.Not (logic.eq (nat) n m)) -> P bool.false) -> P (eqb n m)) -> forall (P:(bool.bool -> Prop)), ((logic.eq (nat) (S n) (S m)) -> P bool.true) -> ((connectives.Not (logic.eq (nat) (S n) (S m))) -> P bool.false) -> P (y (S m)))) ((((((sym_eq_filter_nat_type_S) (nat -> bool.bool)) (eqb_body)) (n)) (fun (y:(nat -> bool.bool)) => (forall (P:(bool.bool -> Prop)), ((logic.eq (nat) n m) -> P bool.true) -> ((connectives.Not (logic.eq (nat) n m)) -> P bool.false) -> P (eqb n m)) -> forall (P:(bool.bool -> Prop)), ((logic.eq (nat) (S n) (S m)) -> P bool.true) -> ((connectives.Not (logic.eq (nat) (S n) (S m))) -> P bool.false) -> P (y (S m)))) ((((sym_eq_eqb_body_S) (n)) (fun (y:(nat -> bool.bool)) => (forall (P:(bool.bool -> Prop)), ((logic.eq (nat) n m) -> P bool.true) -> ((connectives.Not (logic.eq (nat) n m)) -> P bool.false) -> P (eqb n m)) -> forall (P:(bool.bool -> Prop)), ((logic.eq (nat) (S n) (S m)) -> P bool.true) -> ((connectives.Not (logic.eq (nat) (S n) (S m))) -> P bool.false) -> P (y (S m)))) (((((((sym_eq_match_nat_type_S) (bool.bool)) (bool.false)) (fun (q:nat) => eqb n q)) (m)) (fun (y:bool.bool) => (forall (P:(bool.bool -> Prop)), ((logic.eq (nat) n m) -> P bool.true) -> ((connectives.Not (logic.eq (nat) n m)) -> P bool.false) -> P (eqb n m)) -> forall (P:(bool.bool -> Prop)), ((logic.eq (nat) (S n) (S m)) -> P bool.true) -> ((connectives.Not (logic.eq (nat) (S n) (S m))) -> P bool.false) -> P y)) (fun (auto:forall (P:(bool.bool -> Prop)), ((logic.eq (nat) n m) -> P bool.true) -> ((connectives.Not (logic.eq (nat) n m)) -> P bool.false) -> P (eqb n m)) => (fun (P:bool.bool -> Prop) => fun (auto':(logic.eq (nat) (S n) (S m)) -> P bool.true) => (fun (auto'':(connectives.Not (logic.eq (nat) (S n) (S m))) -> P bool.false) => ((((auto) (P)) (fun (auto''':logic.eq (nat) n m) => ((auto') (((((((logic.rewrite_l) (nat)) (n)) (fun (__:nat) => logic.eq (nat) (S n) (S __))) (((logic.refl) (nat)) (S n))) (m)) (auto'''))))) (fun (auto''':connectives.Not (logic.eq (nat) n m)) => ((auto'') ((((not_eq_S) (n)) (m)) (auto''')))))))))))).
